Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -5496,4 +6660,167 @@
                ENDIF
            ENDIF
+
+!--------------------------------------------------------------
+                DO  kw = nzb_wall, nzt_wall
+
+!
+!--                Calculate soil diffusivity at the center of the soil layers
+                   lambda_green_temp(kw) = (- b_ch * surf_usm_h%gamma_w_green_sat(kw,m) * psi_sat       &
+                                     / swc_sat_h(kw,m) ) * ( MAX( swc_h(kw,m),    &
+                                     wilt_h(kw,m) ) / swc_sat_h(kw,m) )**(           &
+                                     b_ch + 2.0_wp )
+
+!
+!--                Parametrization of Van Genuchten
+                   IF ( soil_type /= 7 )  THEN
+!
+!--                   Calculate the hydraulic conductivity after Van Genuchten 
+!--                   (1980)
+                      h_vg = ( ( (swc_res_h(kw,m) - swc_sat_h(kw,m)) / ( swc_res_h(kw,m) -    &
+                                 MAX( swc_h(kw,m), wilt_h(kw,m) ) ) )**(      &
+                                 surf_usm_h%n_vg_green(m) / (surf_usm_h%n_vg_green(m) - 1.0_wp ) ) - 1.0_wp  &
+                             )**( 1.0_wp / surf_usm_h%n_vg_green(m) ) / surf_usm_h%alpha_vg_green(m)
+
+
+                      gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( ( (1.0_wp +         &
+                                      ( surf_usm_h%alpha_vg_green(m) * h_vg )**surf_usm_h%n_vg_green(m))**(  &
+                                      1.0_wp - 1.0_wp / surf_usm_h%n_vg_green(m) ) - (        &
+                                      surf_usm_h%alpha_vg_green(m) * h_vg )**( surf_usm_h%n_vg_green(m)      &
+                                      - 1.0_wp) )**2 )                         &
+                                      / ( ( 1.0_wp + ( surf_usm_h%alpha_vg_green(m) * h_vg    &
+                                      )**surf_usm_h%n_vg_green(m) )**( ( 1.0_wp  - 1.0_wp     &
+                                      / surf_usm_h%n_vg_green(m) ) *( surf_usm_h%l_vg_green(m) + 2.0_wp) ) )
+
+!
+!--                Parametrization of Clapp & Hornberger
+                   ELSE
+                      gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( swc_h(kw,m)       &
+                                      / swc_sat_h(kw,m) )**(2.0_wp * b_ch + 3.0_wp)
+                   ENDIF
+
+                ENDDO
+
+!
+!--             Prognostic equation for soil moisture content. Only performed,
+!--             when humidity is enabled in the atmosphere
+                IF ( humidity )  THEN
+!
+!--                Calculate soil diffusivity (lambda_w) at the _stag level 
+!--                using linear interpolation. To do: replace this with
+!--                ECMWF-IFS Eq. 8.81
+                   DO  kw = nzb_wall, nzt_wall-1
+                     
+                      surf_usm_h%lambda_w_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
+                                        * 0.5_wp
+                      surf_usm_h%gamma_w_green(kw,m)  = ( gamma_green_temp(kw+1) + gamma_green_temp(kw) )    &
+                                        * 0.5_wp
+
+                   ENDDO
+
+!
+!
+!--                In case of a closed bottom (= water content is conserved), 
+!--                set hydraulic conductivity to zero to that no water will be 
+!--                lost in the bottom layer.
+                   IF ( conserve_water_content )  THEN
+                      surf_usm_h%gamma_w_green(kw,m) = 0.0_wp
+                   ELSE
+                      surf_usm_h%gamma_w_green(kw,m) = gamma_green_temp(nzt_wall)
+                   ENDIF     
+
+!--                The root extraction (= root_extr * qsws_veg_eb / (rho_l     
+!--                * l_v)) ensures the mass conservation for water. The         
+!--                transpiration of plants equals the cumulative withdrawals by 
+!--                the roots in the soil. The scheme takes into account the 
+!--                availability of water in the soil layers as well as the root 
+!--                fraction in the respective layer. Layer with moisture below 
+!--                wilting point will not contribute, which reflects the 
+!--                preference of plants to take water from moister layers.
+
+!
+!--                Calculate the root extraction (ECMWF 7.69, the sum of 
+!--                root_extr = 1). The energy balance solver guarantees a 
+!--                positive transpiration, so that there is no need for an 
+!--                additional check.
+                   m_total = 0.0_wp
+                   DO  kw = nzb_wall, nzt_wall
+                       IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
+                          m_total = m_total + rootfr_h(kw,m) * swc_h(kw,m)
+                       ENDIF
+                   ENDDO  
+
+                   IF ( m_total > 0.0_wp )  THEN
+                      DO  kw = nzb_wall, nzt_wall
+                         IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
+                            root_extr_green(kw) = rootfr_h(kw,m) * swc_h(kw,m)      &
+                                                            / m_total
+                         ELSE
+                            root_extr_green(kw) = 0.0_wp
+                         ENDIF
+                      ENDDO
+                   ENDIF
+
+!
+!--                Prognostic equation for soil water content m_soil.
+                   tend(:) = 0.0_wp
+
+                   tend(nzb_wall) = ( surf_usm_h%lambda_w_green(nzb_wall,m) * (               &
+                            swc_h(nzb_wall+1,m) - swc_h(nzb_wall,m) )    &
+                            * surf_usm_h%ddz_green(nzb_wall+1,m) - surf_usm_h%gamma_w_green(nzb_wall,m) - ( &
+                               root_extr_green(nzb_wall) * surf_usm_h%qsws_veg_eb(m)          &
+!                                + surf_usm_h%qsws_soil_eb_green(m)
+                                  ) * drho_l_lv )             &
+                                 * surf_usm_h%ddz_green_stag(nzb_wall,m)
+
+                   DO  kw = nzb_wall+1, nzt_wall-1
+                      tend(kw) = ( surf_usm_h%lambda_w_green(kw,m) * ( swc_h(kw+1,m)          &
+                                - swc_h(kw,m) ) * surf_usm_h%ddz_green(kw+1,m)              &
+                                - surf_usm_h%gamma_w_green(kw,m)                               &
+                                - surf_usm_h%lambda_w_green(kw-1,m) * (swc_h(kw,m) -         &
+                                swc_h(kw-1,m)) * surf_usm_h%ddz_green(kw,m)                 &
+                                + surf_usm_h%gamma_w_green(kw-1,m) - (root_extr_green(kw)             &
+                                * surf_usm_h%qsws_veg_eb(m) * drho_l_lv)                &
+                                ) * surf_usm_h%ddz_green_stag(kw,m)
+
+                   ENDDO
+                   tend(nzt_wall) = ( - surf_usm_h%gamma_w_green(nzt_wall,m)                  &
+                                           - surf_usm_h%lambda_w_green(nzt_wall-1,m)          &
+                                           * (swc_h(nzt_wall,m)             &
+                                           - swc_h(nzt_wall-1,m))           &
+                                           * surf_usm_h%ddz_green(nzt_wall,m)                &
+                                           + surf_usm_h%gamma_w_green(nzt_wall-1,m) - (       &
+                                             root_extr_green(nzt_wall)               &
+                                           * surf_usm_h%qsws_veg_eb(m) * drho_l_lv  )   &
+                                     ) * surf_usm_h%ddz_green_stag(nzt_wall,m)             
+
+                   swc_h_p(nzb_wall:nzt_wall,m) = swc_h(nzb_wall:nzt_wall,m)&
+                                                   + dt_3d * ( tsc(2) * tend(:)   &
+                                                   + tsc(3) * surf_usm_h%tswc_h_m(:,m) )   
+   
+!
+!--                Account for dry soils (find a better solution here!)
+                   DO  kw = nzb_wall, nzt_wall
+                      IF ( swc_h_p(kw,m) < 0.0_wp )  swc_h_p(kw,m) = 0.0_wp
+                   ENDDO
+
+!
+!--                Calculate m_soil tendencies for the next Runge-Kutta step
+                   IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                      IF ( intermediate_timestep_count == 1 )  THEN
+                         DO  kw = nzb_wall, nzt_wall
+                            surf_usm_h%tswc_h_m(kw,m) = tend(kw)
+                         ENDDO
+                      ELSEIF ( intermediate_timestep_count <                   &
+                               intermediate_timestep_count_max )  THEN
+                         DO  kw = nzb_wall, nzt_wall
+                            surf_usm_h%tswc_h_m(kw,m) = -9.5625_wp * tend(kw) + 5.3125_wp&
+                                     * surf_usm_h%tswc_h_m(kw,m)
+                         ENDDO
+                      ENDIF
+                   ENDIF
+                ENDIF
+!--------------------------------------------------------------
+ENDIF
+           
         ENDDO
 
@@ -5502,4 +6829,7 @@
         DO  l = 0, 3                              
            DO  m = 1, surf_usm_v(l)%ns
+
+if (surf_usm_v(l)%frac(ind_pav_green,m).gt.0.0_wp) then
+  if (1.gt.2) then
 !
 !--           Obtain indices
@@ -5553,4 +6883,11 @@
                   ENDIF
               ENDIF
+endif
+
+DO  kw = nzb_wall, nzt_wall+1
+t_green_v(l)%t(kw,m) = t_wall_v(l)%t(nzb_wall,m)
+ENDDO
+              
+ENDIF
 
            ENDDO
@@ -5586,5 +6923,6 @@
                            roof_inner_temperature,                             &
                            soil_inner_temperature,                             &
-                           window_inner_temperature
+                           window_inner_temperature,                           &
+                           usm_wall_mod
 
        NAMELIST /urban_surface_parameters/                                     &
@@ -5604,5 +6942,6 @@
                            roof_inner_temperature,                             &
                            soil_inner_temperature,                             &
-                           window_inner_temperature
+                           window_inner_temperature,                           &
+                           usm_wall_mod
                            
                            
@@ -5842,8 +7181,8 @@
        LOGICAL, INTENT(OUT)  ::  found 
        
-       REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE   ::  tmp_surf_h, tmp_surf_window_h, tmp_surf_green_h
+       REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE   ::  tmp_surf_wall_h, tmp_surf_window_h, tmp_surf_green_h
        REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  tmp_wall_h, tmp_window_h, tmp_green_h
        
-       TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_v, tmp_surf_window_v, tmp_surf_green_v
+       TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_wall_v, tmp_surf_window_v, tmp_surf_green_v
        TYPE( t_wall_vertical ), DIMENSION(0:3), SAVE ::  tmp_wall_v, tmp_window_v, tmp_green_v
 
@@ -5858,5 +7197,5 @@
                    READ ( 13 ) ns_h_on_file_usm
                 
-                   IF ( ALLOCATED( tmp_surf_h ) ) DEALLOCATE( tmp_surf_h )
+                   IF ( ALLOCATED( tmp_surf_wall_h ) ) DEALLOCATE( tmp_surf_wall_h )
                    IF ( ALLOCATED( tmp_wall_h ) ) DEALLOCATE( tmp_wall_h ) 
                    IF ( ALLOCATED( tmp_surf_window_h ) )                       &
@@ -5873,5 +7212,5 @@
 !--                current processor, as the number of processors between 
 !--                restarts can change. 
-                   ALLOCATE( tmp_surf_h(1:ns_h_on_file_usm) )
+                   ALLOCATE( tmp_surf_wall_h(1:ns_h_on_file_usm) )
                    ALLOCATE( tmp_wall_h(nzb_wall:nzt_wall+1,                   &
                                         1:ns_h_on_file_usm) )
@@ -5890,6 +7229,6 @@
 
                    DO  l = 0, 3
-                      IF ( ALLOCATED( tmp_surf_v(l)%t ) )                      &
-                         DEALLOCATE( tmp_surf_v(l)%t )
+                      IF ( ALLOCATED( tmp_surf_wall_v(l)%t ) )                      &
+                         DEALLOCATE( tmp_surf_wall_v(l)%t )
                       IF ( ALLOCATED( tmp_wall_v(l)%t ) )                      &
                          DEALLOCATE( tmp_wall_v(l)%t )
@@ -5911,5 +7250,5 @@
 !--                restarts can change. 
                    DO  l = 0, 3
-                      ALLOCATE( tmp_surf_v(l)%t(1:ns_v_on_file_usm(l)) )
+                      ALLOCATE( tmp_surf_wall_v(l)%t(1:ns_v_on_file_usm(l)) )
                       ALLOCATE( tmp_wall_v(l)%t(nzb_wall:nzt_wall+1,           &
                                                 1:ns_v_on_file_usm(l) ) )
@@ -5950,13 +7289,13 @@
                 ENDIF
           
-             CASE ( 't_surf_h' )
+             CASE ( 't_surf_wall_h' )
 #if defined( __nopointer )                   
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_h ) )                         &
-                      ALLOCATE( t_surf_h(1:surf_usm_h%ns) )
-                   READ ( 13 )  tmp_surf_h
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_h ) )                         &
+                      ALLOCATE( t_surf_wall_h(1:surf_usm_h%ns) )
+                   READ ( 13 )  tmp_surf_wall_h
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_h, tmp_surf_h,                  &
+                                        t_surf_wall_h, tmp_surf_wall_h,                  &
                                         surf_usm_h%start_index,                &  
                                         start_index_on_file,                   &
@@ -5968,11 +7307,11 @@
 #else                  
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_h_1 ) )                       &
-                      ALLOCATE( t_surf_h_1(1:surf_usm_h%ns) )
-                   READ ( 13 )  tmp_surf_h
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_h_1 ) )                       &
+                      ALLOCATE( t_surf_wall_h_1(1:surf_usm_h%ns) )
+                   READ ( 13 )  tmp_surf_wall_h
                 ENDIF              
                 CALL surface_restore_elements(                                 &
-                                        t_surf_h_1, tmp_surf_h,                &
-                                        surf_usm_h%start_index,                & 
+                                        t_surf_wall_h_1, tmp_surf_wall_h,      &
+                                        surf_usm_h%start_index,                &
                                         start_index_on_file,                   &
                                         end_index_on_file,                     &
@@ -5983,13 +7322,13 @@
 #endif
 
-             CASE ( 't_surf_v(0)' )
+             CASE ( 't_surf_wall_v(0)' )
 #if defined( __nopointer )            
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v(0)%t ) )                    &
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v(0)%t ) )                    &
                       ALLOCATE( t_surf_v(0)%t(1:surf_usm_v(0)%ns) )
-                   READ ( 13 )  tmp_surf_v(0)%t
+                   READ ( 13 )  tmp_surf_wall_v(0)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v(0)%t, tmp_surf_v(0)%t,        &
+                                        t_surf_wall_v(0)%t, tmp_surf_wall_v(0)%t,        &
                                         surf_usm_v(0)%start_index,             &
                                         start_index_on_file,                   &
@@ -6001,10 +7340,10 @@
 #else                      
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v_1(0)%t ) )                  &
-                      ALLOCATE( t_surf_v_1(0)%t(1:surf_usm_v(0)%ns) )
-                   READ ( 13 )  tmp_surf_v(0)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(0)%t ) )                  &
+                      ALLOCATE( t_surf_wall_v_1(0)%t(1:surf_usm_v(0)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(0)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v_1(0)%t, tmp_surf_v(0)%t,      &
+                                        t_surf_wall_v_1(0)%t, tmp_surf_wall_v(0)%t,      &
                                         surf_usm_v(0)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6016,13 +7355,13 @@
 #endif
                       
-             CASE ( 't_surf_v(1)' )
+             CASE ( 't_surf_wall_v(1)' )
 #if defined( __nopointer )        
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v(1)%t ) )                    &
-                      ALLOCATE( t_surf_v(1)%t(1:surf_usm_v(1)%ns) )
-                   READ ( 13 )  tmp_surf_v(1)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v(1)%t ) )                    &
+                      ALLOCATE( t_surf_wall_v(1)%t(1:surf_usm_v(1)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(1)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v(1)%t, tmp_surf_v(1)%t,        &
+                                        t_surf_wall_v(1)%t, tmp_surf_wall_v(1)%t,        &
                                         surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6034,10 +7373,10 @@
 #else                      
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v_1(1)%t ) )                  &
-                      ALLOCATE( t_surf_v_1(1)%t(1:surf_usm_v(1)%ns) )
-                   READ ( 13 )  tmp_surf_v(1)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(1)%t ) )                  &
+                      ALLOCATE( t_surf_wall_v_1(1)%t(1:surf_usm_v(1)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(1)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v_1(1)%t, tmp_surf_v(1)%t,      &
+                                        t_surf_wall_v_1(1)%t, tmp_surf_wall_v(1)%t,      &
                                         surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6049,13 +7388,13 @@
 #endif
 
-             CASE ( 't_surf_v(2)' )
+             CASE ( 't_surf_wall_v(2)' )
 #if defined( __nopointer )          
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v(2)%t ) )                    &
-                      ALLOCATE( t_surf_v(2)%t(1:surf_usm_v(2)%ns) )
-                   READ ( 13 )  tmp_surf_v(2)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v(2)%t ) )                    &
+                      ALLOCATE( t_surf_wall_v(2)%t(1:surf_usm_v(2)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(2)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v(2)%t, tmp_surf_v(2)%t,        &
+                                        t_surf_wall_v(2)%t, tmp_surf_wall_v(2)%t,        &
                                         surf_usm_v(2)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6067,10 +7406,10 @@
 #else                      
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v_1(2)%t ) )                  &
-                      ALLOCATE( t_surf_v_1(2)%t(1:surf_usm_v(2)%ns) )
-                   READ ( 13 )  tmp_surf_v(2)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(2)%t ) )                  &
+                      ALLOCATE( t_surf_wall_v_1(2)%t(1:surf_usm_v(2)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(2)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v_1(2)%t, tmp_surf_v(2)%t,      &
+                                        t_surf_wall_v_1(2)%t, tmp_surf_wall_v(2)%t,      &
                                         surf_usm_v(2)%start_index,             &  
                                         start_index_on_file,                   &
@@ -6082,13 +7421,13 @@
 #endif
                       
-             CASE ( 't_surf_v(3)' )
+             CASE ( 't_surf_wall_v(3)' )
 #if defined( __nopointer )    
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v(3)%t ) )                    &
-                      ALLOCATE( t_surf_v(3)%t(1:surf_usm_v(3)%ns) )
-                   READ ( 13 )  tmp_surf_v(3)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v(3)%t ) )                    &
+                      ALLOCATE( t_surf_wall_v(3)%t(1:surf_usm_v(3)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(3)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v(3)%t, tmp_surf_v(3)%t,        &
+                                        t_surf_wall_v(3)%t, tmp_surf_wall_v(3)%t,        &
                                         surf_usm_v(3)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6100,10 +7439,10 @@
 #else                      
                 IF ( k == 1 )  THEN
-                   IF ( .NOT.  ALLOCATED( t_surf_v_1(3)%t ) )                  &
-                      ALLOCATE( t_surf_v_1(3)%t(1:surf_usm_v(3)%ns) )
-                   READ ( 13 )  tmp_surf_v(3)%t
+                   IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(3)%t ) )                  &
+                      ALLOCATE( t_surf_wall_v_1(3)%t(1:surf_usm_v(3)%ns) )
+                   READ ( 13 )  tmp_surf_wall_v(3)%t
                 ENDIF
                 CALL surface_restore_elements(                                 &
-                                        t_surf_v_1(3)%t, tmp_surf_v(3)%t,      &
+                                        t_surf_wall_v_1(3)%t, tmp_surf_wall_v(3)%t,      &
                                         surf_usm_v(3)%start_index,             & 
                                         start_index_on_file,                   &
@@ -6706,7 +8045,7 @@
                 CALL surface_restore_elements(                                 &
                                         t_green_v(1)%t, tmp_green_v(1)%t,      &
-                                        surf_usm_v(1)%start_index,             &
+                                        surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
-                                        end_index_on_file,                     &
+                                        end_index_on_file ,                    &
                                         nxlc, nysc,                            &
                                         nxlf, nxrf, nysf, nynf,                &
@@ -6722,5 +8061,5 @@
                 CALL surface_restore_elements(                                 &
                                         t_green_v_1(1)%t, tmp_green_v(1)%t,    &
-                                        surf_usm_v(1)%start_index,             &
+                                        surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
                                         end_index_on_file,                     &
@@ -6879,5 +8218,5 @@
                                         surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
-                                        end_index_on_file,                     &
+                                        end_index_on_file ,                    &
                                         nxlc, nysc,                            &
                                         nxlf, nxrf, nysf, nynf,                &
@@ -7002,5 +8341,5 @@
         INTEGER(iwp), DIMENSION(0:17, nysg:nyng, nxlg:nxrg)   :: usm_par
         REAL(wp), DIMENSION(1:14, nysg:nyng, nxlg:nxrg)       :: usm_val
-        INTEGER(iwp)                                          :: k, l, iw, jw, kw, it, ip, ii, ij, m
+        INTEGER(iwp)                                          :: k, l, d, iw, jw, kw, it, ip, ii, ij, m
         INTEGER(iwp)                                          :: i, j
         INTEGER(iwp)                                          :: nz, roof, dirwe, dirsn
@@ -7595,8 +8934,8 @@
 !--                     assign temperatures
                         IF ( d == 0 ) THEN
-                           t_surf_h(isurfl) = rtsurf
+                           t_surf_wall_h(isurfl) = rtsurf
                            t_wall_h(:,isurfl) = rtwall(:)
                         ELSE
-                           t_surf_v(d-1)%t(isurfl) = rtsurf
+                           t_surf_wall_v(d-1)%t(isurfl) = rtsurf
                            t_wall_v(d-1)%t(:,isurfl) = rtwall(:)
                         ENDIF
@@ -7633,11 +8972,20 @@
 !> TODO better description
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_surface_energy_balance
+    SUBROUTINE usm_surface_energy_balance( spinup )
+
 
         IMPLICIT NONE
 
-        INTEGER(iwp)                          :: i, j, k, l, m      !< running indices
+        INTEGER(iwp)                          :: i, j, k, l, d, m   !< running indices
         
-        REAL(wp)                              :: stend              !< surface tendency
+        INTEGER(iwp) ::  i_off     !< offset to determine index of surface element, seen from atmospheric grid point, for x
+        INTEGER(iwp) ::  j_off     !< offset to determine index of surface element, seen from atmospheric grid point, for y
+        INTEGER(iwp) ::  k_off     !< offset to determine index of surface element, seen from atmospheric grid point, for z
+
+        LOGICAL                               :: spinup             !true during spinup
+        
+        REAL(wp)                              :: u1,v1,w1           !< near wall u,v,w
+        REAL(wp)                              :: stend_wall              !< surface tendency
+        
         REAL(wp)                              :: stend_window       !< surface tendency
         REAL(wp)                              :: stend_green        !< surface tendency
@@ -7648,5 +8996,5 @@
         REAL(wp)                              :: coef_window_2      !< second  coeficient for prognostic window equation
         REAL(wp)                              :: coef_green_2       !< second  coeficient for prognostic green wall equation
-        REAL(wp)                              :: rho_cp             !< rho_wall_surface * cp
+        REAL(wp)                              :: rho_cp             !< rho_wall_surface * c_p
         REAL(wp)                              :: f_shf              !< factor for shf_eb
         REAL(wp)                              :: f_shf_window       !< factor for shf_eb window
@@ -7659,5 +9007,28 @@
         INTEGER(iwp)                          :: dhour              !< simulated hour of day (in UTC)
         REAL(wp)                              :: acoef              !< actual coefficient of diurnal profile of anthropogenic heat
-
+        REAL(wp) ::  f1,          & !< resistance correction term 1
+                     f2,          & !< resistance correction term 2
+                     f3,          & !< resistance correction term 3
+                     e,           & !< water vapour pressure
+                     e_s,         & !< water vapour saturation pressure
+                     e_s_dt,      & !< derivate of e_s with respect to T
+                     tend,        & !< tendency
+                     dq_s_dt,     & !< derivate of q_s with respect to T
+                     f_qsws,      & !< factor for qsws
+                     f_qsws_veg,  & !< factor for qsws_veg
+                     f_qsws_liq,  & !< factor for qsws_liq
+                     m_liq_max,   & !< maxmimum value of the liq. water reservoir
+                     qv1,         & !< specific humidity at first grid level
+                     m_max_depth = 0.0002_wp, & ! Maximum capacity of the water reservoir (m)
+                     rho_lv,      &
+                     drho_l_lv,   &
+                     q_s
+
+!
+!--     Index offset of surface element point with respect to adjoining 
+!--     atmospheric grid point 
+        k_off = surf_usm_h%koff
+        j_off = surf_usm_h%joff
+        i_off = surf_usm_h%ioff
 
 !        
@@ -7683,7 +9054,20 @@
            ENDIF
 #if ! defined( __nopointer )
+!            pt1  = pt(k,j,i)
+           IF ( humidity )  THEN
+              qv1 = q(k,j,i)
+           ELSE
+              qv1 = 0.0_wp
+           ENDIF
 !
 !--        calculate rho * c_p coefficient at surface layer
            rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_h%pt1(m) * exner(k) )
+
+if (surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) then
+!
+!--         Calculate frequently used parameters
+            rho_lv    = rho_cp / c_p * l_v
+            drho_l_lv = 1.0_wp / (rho_l * l_v)
+endif
 #endif
 !
